//+------------------------------------------------------------------+ 
//|   TRO_ATR_LINES_HL                                               | 
//|                                                                  | 
//|   Copyright  2014, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 1673, BANDON, OR 97411                                  |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/forex.aspx                |  
//| as your forex broker...tell them therumpledone sent you!         |  
//+------------------------------------------------------------------+ 
//|                                                                  |
//| go to www.kreslik.com for the latest indicator updates           |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2014, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

//+------------------------------------------------------------------+ 

#property indicator_chart_window

extern bool   TURN_OFF         = false ; 
extern bool   Show_ShadeATR    = true ; 
extern bool   Show_Open        = true ;
extern bool   Show_HighLow     = true ;
extern bool   Show_PrevHiLo    = true ;
extern bool   Show_Mult_Lines  = false ;
extern bool   Show_Boxes       = true ;  
extern bool   Show_Labels      = true ; 

//extern int    ShiftLabel  =  7 ;


extern int myPeriod = 0 ;
extern int myShift  = 1 ;

extern int  iATRperiod       = 1440;  
extern double  iATRMult       = 0.50;  
 
extern int  iATRstart        = 2; 
extern int  iATRend          = 14;  

extern int    Line_Style    = STYLE_DOT ;
extern int    Line_Width    = 1 ;
 

extern color  Line_Color_Open     = Orange ;   
extern color  Line_Color_ATR      = Chocolate ;
extern color  Line_Color_High     = Red ; 
extern color  Line_Color_Low      = Blue ; 
extern color  Line_Color_PrevHigh = Violet ; 
extern color  Line_Color_PrevLow  = Violet ; 
extern color  colorATRHighShade   = Chocolate  ;
extern color  colorATRLowShade    = Chocolate  ;


 


string lbl[30], lbl2[30];
int n, j, i ;

string symbol,  tChartPeriod, tATRPeriod, ShortName , TAG , text, tATRMult;  

int    digits, period, win, BarShift ; 

double point ;



datetime DateTime ; 
   
double  a_Open,a_high, a_low , a_ATR , W1_ATR, VALUE , ATRThreshold, ATRMult, LOW, HIGH, D1OPEN ;      
double  a_Range, maxATR, minATR, p_High, p_Low ; 

int min, max ;

//+------------------------------------------------------------------+

int init()
{
   if(myPeriod == 0) { period = Period() ; } else { period = myPeriod ; }  

   symbol       =  Symbol() ;
   digits       =  Digits ;
   point        =  Point ;
   TAG          =  "troATRLHL" ;
   ShortName    =  TAG+symbol+iATRperiod+myShift  ;

   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   
    
   tATRPeriod = TimeFrameToString(iATRperiod) ;
      
   deinit();
   
   return(0);
  }
//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int LL = StringLen(Prefix);
   int ii = 0; 
   while(ii < ObjectsTotal())
     {
       string ObjName = ObjectName(ii);
       if(StringSubstr(ObjName, 0, LL) != Prefix) 
         { 
           ii++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }  
      
//+------------------------------------------------------------------+
int deinit()
{
 
   ObDeleteObjectsByPrefix(TAG);  
   TRO() ;
return(0);
}
  
//+------------------------------------------------------------------+
void DoATR( double dOpen, double dATR, bool dPlus)
{
   
  if(dPlus) { VALUE    = dOpen + ( dATR * iATRMult) ; } 
  else      { VALUE    = dOpen - ( dATR * iATRMult) ; } 

}
  
//+------------------------------------------------------------------+
int start()
{
ObDeleteObjectsByPrefix(ShortName);  

   if( TURN_OFF ) { return(0) ; }
   
n       = 10;
j       = 0 ;
    

DateTime  = iTime(symbol,iATRperiod,0) ; 

a_Open    = iOpen(symbol,iATRperiod,0);   
p_High    = iHigh(symbol,iATRperiod,1);   
p_Low     = iLow(symbol,iATRperiod,1); 

D1OPEN = iOpen(symbol,PERIOD_D1,0) ;
HIGH   = iHigh(symbol,iATRperiod,0) ;
LOW    = iLow(symbol,iATRperiod,0) ;
     
maxATR = -1 ;
minATR = 9999999 ;
 
for( i = iATRstart; i <= iATRend; i++ )
{     
      
   a_ATR    = iATR(symbol,iATRperiod,i,0);  

   if( a_ATR > maxATR) { max = i; maxATR = a_ATR ; }
   if( a_ATR < minATR) { min = i; minATR = a_ATR ; }

} // for


j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(minATR + LOW ,lbl[j], Line_Color_ATR , Line_Style , Line_Width, DateTime, tATRPeriod + " LOW + ATR("+min+")"   ) ;

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(maxATR + LOW ,lbl[j], Line_Color_ATR , Line_Style , Line_Width, DateTime, tATRPeriod + " LOW + ATR("+max+")"   ) ;

DoATR(LOW, minATR, true) ;
tATRMult =  DoubleToStr(iATRMult,2) ;


if( Show_Mult_Lines && Close[0] > D1OPEN )
{

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(VALUE ,lbl[j], Line_Color_ATR , Line_Style , Line_Width, DateTime, tATRPeriod + " LOW + ATR("+min+")*"+tATRMult   ) ;

DoATR(LOW, maxATR, true) ;

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(VALUE ,lbl[j], Line_Color_ATR , Line_Style , Line_Width, DateTime, tATRPeriod + " LOW + ATR("+max+")*"+tATRMult    ) ;
}
else

if( Show_Mult_Lines && Close[0] < D1OPEN )
{
DoATR(HIGH, minATR, false) ;

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(VALUE ,lbl[j], Line_Color_ATR , Line_Style , Line_Width, DateTime, tATRPeriod + " HIGH - ATR("+min+")*"+tATRMult   ) ;

DoATR(HIGH, maxATR, false) ;

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(VALUE ,lbl[j], Line_Color_ATR , Line_Style , Line_Width, DateTime, tATRPeriod + " HIGH - ATR("+max+")*"+tATRMult   ) ;
} // if show

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(HIGH - minATR ,lbl[j], Line_Color_ATR , Line_Style , Line_Width, DateTime, tATRPeriod + " HIGH - ATR("+min+")"    ) ;

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(HIGH - maxATR ,lbl[j], Line_Color_ATR , Line_Style , Line_Width, DateTime, tATRPeriod + " HIGH - ATR("+max+")"    ) ;



if(Show_Open)
{
j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(a_Open ,lbl[j], Line_Color_Open , Line_Style , Line_Width, DateTime, tATRPeriod + " Open"    ) ;
}



if(Show_HighLow)
{
j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(HIGH ,lbl[j], Line_Color_High , Line_Style , Line_Width, DateTime, tATRPeriod + " High[0]"    ) ;

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(LOW ,lbl[j], Line_Color_Low , Line_Style , Line_Width, DateTime, tATRPeriod + " Low[0]"    ) ;
}

if(Show_PrevHiLo)
{
j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(p_High ,lbl[j], Line_Color_PrevHigh , Line_Style , Line_Width, DateTime, tATRPeriod + " High[1]"    ) ;

j       = j + 1 ;
lbl[j]  = ShortName+j;
drawLine(p_Low ,lbl[j], Line_Color_PrevLow , Line_Style , Line_Width, DateTime, tATRPeriod + " Low[1]"    ) ;
}
if(Show_ShadeATR)
{
        if (ObjectFind(ShortName+"21") != 0)
        ObjectCreate(ShortName+"21", OBJ_RECTANGLE, 0, 0, 0);
        ObjectSet(ShortName+"21", OBJPROP_TIME1, Time[0]);
        ObjectSet(ShortName+"21", OBJPROP_PRICE1, minATR + LOW );
        ObjectSet(ShortName+"21", OBJPROP_TIME2, DateTime);
        ObjectSet(ShortName+"21", OBJPROP_PRICE2, maxATR + LOW  ); // ATR + D1_low 
        ObjectSet(ShortName+"21", OBJPROP_COLOR, colorATRHighShade);
        ObjectSet(ShortName+"21", OBJPROP_BACK, true);         

        if (ObjectFind(ShortName+"22") != 0)
        ObjectCreate(ShortName+"22", OBJ_RECTANGLE, 0, 0, 0);
        ObjectSet(ShortName+"22", OBJPROP_TIME1, Time[0]);
        ObjectSet(ShortName+"22", OBJPROP_PRICE1, HIGH - minATR);
        ObjectSet(ShortName+"22", OBJPROP_TIME2, DateTime);
        ObjectSet(ShortName+"22", OBJPROP_PRICE2, HIGH - maxATR); // D1_high - ATR 
        ObjectSet(ShortName+"22", OBJPROP_COLOR, colorATRLowShade);
        ObjectSet(ShortName+"22", OBJPROP_BACK, true); 
            
} // if(Show_Shade)

return(0);
}
 

//+------------------------------------------------------------------+
 
void drawLine(double lvl,string name, color Col,int type, int width, datetime TimeBar, string xtext)
{

         if(ObjectFind(name) != 0)
         {
            ObjectCreate(name, OBJ_TREND, 0, TimeBar, lvl,Time[0],lvl);
            

            ObjectSet(name, OBJPROP_STYLE, type);

            
            ObjectSet(name, OBJPROP_COLOR, Col);
            ObjectSet(name,OBJPROP_WIDTH,width);
             ObjectSet(name,OBJPROP_RAY,false);           
         }
         else
         {
            ObjectDelete(name);
            ObjectCreate(name, OBJ_TREND, 0, TimeBar, lvl,Time[0],lvl);
            
            ObjectSet(name, OBJPROP_STYLE, type);
            
            ObjectSet(name, OBJPROP_COLOR, Col);        
            ObjectSet(name,OBJPROP_WIDTH,width);
             ObjectSet(name,OBJPROP_RAY,false);             
         }
 
 
 
   if(Show_Labels)
   {         
      string Obj0002 = name+"linelbl" ;

 //     datetime LabelTime = Time[0]+Period()*60*ShiftLabel ;
//+------------------------------------------------------------------+
//Determine the current chart scale (chart scale number should be 0-5) use to place labels to right of price arrow
     
  int Chart_Scale  ,Bar_Width  ; 
     
  Chart_Scale = ChartScaleGet();
  
  //Set bar widths             
        if(Chart_Scale == 0) {Bar_Width = 120;}
  else {if(Chart_Scale == 1) {Bar_Width = 60;}      
  else {if(Chart_Scale == 2) {Bar_Width = 30;}
  else {if(Chart_Scale == 3) {Bar_Width = 15;}
  else {if(Chart_Scale == 4) {Bar_Width = 8;}
  else {Bar_Width = 4;} }}}}
  
 
     datetime LabelTime = Time[0]+Period()*60*Bar_Width ; // Time[WindowFirstVisibleBar()/2]; // Time[0]+Period()*60*ShiftLabel ;   
     
      ObjectDelete(Obj0002);
   
      if(ObjectFind(Obj0002) != 0)
      {
         ObjectCreate(Obj0002, OBJ_TEXT, 0, LabelTime, lvl);
         ObjectSetText(Obj0002, fFill(xtext,22)  , 8, "Terminal", Col);
      }
      else
      {
         ObjectMove(Obj0002, 0, LabelTime, lvl);
      } // if 
                 
   } // if   

   if(Show_Boxes)
   {  
     string dName = name+"boxes" ;
     if (ObjectFind(dName) != 0)
      {
          ObjectCreate(dName,OBJ_ARROW,0,Time[0],lvl);
          ObjectSet(dName,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(dName,OBJPROP_COLOR,Col);  
      } 
      else
      {
         ObjectMove(dName,0,Time[0],lvl);
      } 
   } // if    
 
}

//+------------------------------------------------------------------+
string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}

//+------------------------------------------------------------------+

string fFill(string filled, int f ) 
{
   string FILLED ;
   
   FILLED = StringSubstr(filled + "                                         ",0,f) ;
   
return(FILLED);
}
//+-------------------------------------------------------------------------------------------+
//| Subroutine:  Get the chart scale number                                                   |
//+-------------------------------------------------------------------------------------------+
int ChartScaleGet()
  {
  long result = -1;
  ChartGetInteger(0,CHART_SCALE,0,result);
  return((int)result);
  }  
  
//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}


//+------------------------------------------------------------------+ 
/*

Comment(

 "\n" , 
"DailyOpen " , DoubleToStr(a_Open,Digits) , "\n" ,
"ATR " , DoubleToStr(a_ATR,Digits) , "\n" , 
"\n" , 
"DailyOpen + ATR " , DoubleToStr(a_Open + a_ATR,Digits) , "\n" , 
"a_high " , DoubleToStr(a_high,Digits) , "\n" ,
"a_low " , DoubleToStr(a_low,Digits) , "\n" ,
"DailyOpen - ATR " , DoubleToStr(a_Open - a_ATR,Digits) , "\n" , 
"") ; 


 Comment("DateTime= ", TimeToStr(DateTime) ) ;
 
 */