//+------------------------------------------------------------------+
//|   TRO_CLOSE_LINE                                                 | 
//|                                                                  | 
//|   Copyright  2009, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/fx/ as your forex broker  |  
//| ...tell them therumpledone sent you!                             |  
//+------------------------------------------------------------------+ 
#property  copyright "Copyright  2009, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 
 
           
#property indicator_chart_window
#property indicator_buffers 6
 
extern bool TURN_OFF    = false ;

extern bool Show_Boxes = true ;  
 
extern int  myBars  =  240 ; 
 
extern int  LineStyle  =  0 ; 
extern int  LineWidth  =  2 ; 
extern color  LineColor  = Orange ; 
extern color colorUp   = Aqua ;
extern color colorEq   = Yellow ;
extern color colorDn   = Magenta ;

extern int myWingDing1  = 119 ; // 171

//---- buffers

double P1Buffer[];
double P2Buffer[];
 
double HBuffer[];
double HBufferUp[];
double HBufferDn[];
double LBuffer[];
double LBufferUp[];
double LBufferDn[];
 
string short_name;
 
string symbol, tChartPeriod, TAG ;  

int    digits, period , j=0, upHits, dnHits, passes ;    
double point ;

string Obj0001,Obj0002,Obj0003,Obj0004,Obj0005,Obj0006,Obj0007,Obj0008,Obj0009,Obj0010,Obj0011;  


double  high, low, HH, LH, HL, LL;  
 
int    nHH, nLL, nHL, nLH;

//+------------------------------------------------------------------+
int init()
{
  
   period       =  Period() ;  
   digits       =  Digits ;   
   point        =  Point ;


   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }   
    
   TAG        = "hhll";     
   short_name = TAG+myBars ;
 
   IndicatorShortName(short_name);
  

   SetIndexArrow(0, myWingDing1); 
   SetIndexArrow(1, myWingDing1); 
   SetIndexArrow(2, myWingDing1); 
   SetIndexArrow(3, myWingDing1);    
   SetIndexArrow(4, myWingDing1); 
   SetIndexArrow(5, myWingDing1); 
      
   SetIndexBuffer(0,HBuffer);
   SetIndexBuffer(1,HBufferUp);   
   SetIndexBuffer(2,HBufferDn);
   SetIndexBuffer(3,LBuffer);
   SetIndexBuffer(4,LBufferUp);   
   SetIndexBuffer(5,LBufferDn);

   SetIndexStyle(0,DRAW_ARROW,LineStyle,LineWidth,colorEq);
   SetIndexStyle(1,DRAW_ARROW,LineStyle,LineWidth,colorUp);
   SetIndexStyle(2,DRAW_ARROW,LineStyle,LineWidth,colorDn); 
   SetIndexStyle(3,DRAW_ARROW,LineStyle,LineWidth,colorEq);
   SetIndexStyle(4,DRAW_ARROW,LineStyle,LineWidth,colorUp);
   SetIndexStyle(5,DRAW_ARROW,LineStyle,LineWidth,colorDn);  
   
   deinit();
   
   return(0);
  }
//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int ll = StringLen(Prefix);
   int ii = 0; 
   while(ii < ObjectsTotal())
     {
       string ObjName = ObjectName(ii);
       if(StringSubstr(ObjName, 0, ll) != Prefix) 
         { 
           ii++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }  
      
//+------------------------------------------------------------------+
int deinit()
{
 
   ObDeleteObjectsByPrefix(TAG);  
   TRO() ;
return(0);
}
   
//+------------------------------------------------------------------+

int start()
{
   if( TURN_OFF ) { deinit(); return(0) ; }
   
   int i,   counted_bars = IndicatorCounted();
//---- check for possible errors
   if(counted_bars < 0) 
       return(-1);
//---- last counted bar will be recounted
   if(counted_bars > 0) 
       counted_bars--;  
   int limit = Bars - counted_bars;

 
   for(i = limit - 1; i >= 0; i--)
   {
      nHH     =  Highest(symbol,period,MODE_HIGH,myBars,i); 
      nLL     =  Lowest(symbol,period,MODE_LOW,myBars,i);     
 
      HH     = iHigh(symbol,period,nHH);  
      LL     = iLow(symbol,period,nLL);      
 
       HBuffer[i]   = HH;       
       LBuffer[i]   = LL;  

   }
 

 
   for(i = 0; i <= limit; i++)
   {
          

       HBufferDn[i] = EMPTY_VALUE; 
       HBufferUp[i] = EMPTY_VALUE;  

       LBufferDn[i] = EMPTY_VALUE; 
       LBufferUp[i] = EMPTY_VALUE;    
       
        if (HBuffer[i] < HBuffer[i+1])
        {
        HBufferDn[i] = HBuffer[i];
        //ColorMA = colorDn ;
        }
        else if (HBuffer[i] > HBuffer[i+1]) 
        {
        HBufferUp[i] = HBuffer[i];  
        //ColorMA = colorUp ;
        }
         else 
         {

         //ColorMA = colorEq ;
         }
 
       
        if (LBuffer[i] < LBuffer[i+1])
        {
        LBufferDn[i] = LBuffer[i];
        //ColorMA = colorDn ;
        }
        else if (LBuffer[i] > LBuffer[i+1]) 
        {
        LBufferUp[i] = LBuffer[i];  
        //ColorMA = colorUp ;
        }
         else 
         {

         //ColorMA = colorEq ;
         }

 
   }
 
   drawBox(short_name+"up",  HBuffer[0], colorEq) ;
   drawBox(short_name+"dn",  LBuffer[0], colorEq) ;
      
   WindowRedraw();

return(0);   
}

//+------------------------------------------------------------------+
 
void drawBox(string name, double lvl, color Col)
{
  

   if(Show_Boxes)
   {  
     string dName = name+"boxes" ;
     if (ObjectFind(dName) != 0)
      {
          ObjectCreate(dName,OBJ_ARROW,0,Time[0],lvl);
          ObjectSet(dName,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(dName,OBJPROP_COLOR,Col);  
      } 
      else
      {
         ObjectMove(dName,0,Time[0],lvl);
      } 
   } // if    
 
}


//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}
//+--------- TRO MODIFICATION ---------------------------------------+   
   
 