//+------------------------------------------------------------------+ 
//|   TRO_BUY_ZONE                                                   | 
//|                                                                  | 
//|   Copyright  2014, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 1673, BANDON, OR 97411                                  |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/forex.aspx                |  
//| as your forex broker...tell them therumpledone sent you!         |  
//+------------------------------------------------------------------+ 
//|                                                                  |
//| go to www.kreslik.com for the latest indicator updates           |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2014, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

//+------------------------------------------------------------------+ 

#property indicator_chart_window 

extern bool   Show_Boxes       = true ;  
extern bool   Show_Labels      = true ; 
extern int    myBoxWidth     = 2;
 
extern int  myPeriod   = PERIOD_D1;
 
extern int  iBuyZone1   = 8;
extern int  iBuyZone2   = 10;
 
extern color Line_Color_Open = Orange ;
extern color colorLONG       = Blue ; 
extern color colorSHORT      = Red ;



string TAG;
  
double dailyopen,   xBuyZone1, xBuyZone2, LongTop, LongBot, ShortTop, ShortBot ,PipsTrigger  ,  xThreshold ; 

datetime DateTime ;
 

//+------------------------------------------------------------------+ 
string symbol, tChartPeriod,  tShortName ;  
int     digits, period, win ; 
double point;

//+------------------------------------------------------------------+ 
int init() 
  { 
   
   if(myPeriod == 0) { period = Period() ; } else { period = myPeriod ; }   
   
   tChartPeriod =  TimeFrameToString(myPeriod) ;  
   digits       =  Digits ;
   point        =  Point ; 
   symbol       =  Symbol() ; 
   
   tShortName   = symbol + tChartPeriod  ; 
    
   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; } 
 

   xBuyZone1   = iBuyZone1 * point ;
   xBuyZone2   = iBuyZone2 * point ;
 
   TAG =  "bz"+ period ;
   deinit();
    
   return(0); 
  } 
  
//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int LL = StringLen(Prefix);
   int ii = 0; 
   while(ii < ObjectsTotal())
     {
       string ObjName = ObjectName(ii);
       if(StringSubstr(ObjName, 0, LL) != Prefix) 
         { 
           ii++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }  
      
//+------------------------------------------------------------------+
int deinit()
{
 
   ObDeleteObjectsByPrefix(TAG);  
   TRO() ;
return(0);
}
   
//+------------------------------------------------------------------+ 
int start() 
  { 
        DateTime  = iTime(symbol,myPeriod,0) ; 
        dailyopen = iOpen(symbol,myPeriod,0) ;
        LongTop   = dailyopen + xBuyZone2 ; 
        LongBot   = dailyopen + xBuyZone1 ;   
        ShortTop  = dailyopen - xBuyZone1 ;   
        ShortBot  = dailyopen - xBuyZone2 ;   


drawLine(dailyopen ,TAG+"oP", Line_Color_Open , 2 , 1, DateTime, tChartPeriod + " Open" ) ; 

drawLine(LongTop ,TAG+"lt", colorLONG , 2 , 1, DateTime, tChartPeriod + " Long Top" ) ;  
drawLine(LongBot ,TAG+"lb", colorLONG , 2 , 1, DateTime, tChartPeriod + " Long Bot" ) ;     

drawLine(ShortTop ,TAG+"st", colorSHORT , 2 , 1, DateTime, tChartPeriod + " Short Top" ) ;  
drawLine(ShortBot ,TAG+"sb", colorSHORT , 2 , 1, DateTime, tChartPeriod + " Short Bot" ) ; 
           

return(0); 
}  
  

//+--------- TRO MODIFICATION ---------------------------------------+  

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}

//+------------------------------------------------------------------+
 
void drawLine(double lvl,string name, color Col,int type, int width, datetime TimeBar, string text)
{

         if(ObjectFind(name) != 0)
         {
            ObjectCreate(name, OBJ_TREND, 0, TimeBar, lvl,Time[0],lvl);
            

            ObjectSet(name, OBJPROP_STYLE, type);

            
            ObjectSet(name, OBJPROP_COLOR, Col);
            ObjectSet(name,OBJPROP_WIDTH,width);
             ObjectSet(name,OBJPROP_RAY,false);           
         }
         else
         {
            ObjectDelete(name);
            ObjectCreate(name, OBJ_TREND, 0, TimeBar, lvl,Time[0],lvl);
            
            ObjectSet(name, OBJPROP_STYLE, type);
            
            ObjectSet(name, OBJPROP_COLOR, Col);        
            ObjectSet(name,OBJPROP_WIDTH,width);
             ObjectSet(name,OBJPROP_RAY,false);             
         }
 
 
 
   if(Show_Labels)
   {         
      string Obj0002 = name+"linelbl" ;
      
      
  //+------------------------------------------------------------------+
//Determine the current chart scale (chart scale number should be 0-5) use to place labels to right of price arrow
     
  int Chart_Scale  ,Bar_Width  ; 
     
  Chart_Scale = ChartScaleGet();
  
  //Set bar widths             
        if(Chart_Scale == 0) {Bar_Width = 120;}
  else {if(Chart_Scale == 1) {Bar_Width = 60;}      
  else {if(Chart_Scale == 2) {Bar_Width = 30;}
  else {if(Chart_Scale == 3) {Bar_Width = 15;}
  else {if(Chart_Scale == 4) {Bar_Width = 8;}
  else {Bar_Width = 4;} }}}}
  
 
     datetime LabelTime = Time[0]+Period()*60*Bar_Width ; // Time[WindowFirstVisibleBar()/2]; // Time[0]+Period()*60*ShiftLabel ;   
             
      
      ObjectDelete(Obj0002);
      
      if(ObjectFind(Obj0002) != 0)
      {
         ObjectCreate(Obj0002, OBJ_TEXT, 0, LabelTime, lvl);
         ObjectSetText(Obj0002,fFill(text,22) , 8, "Terminal", Col);
      }
      else
      {
         ObjectMove(Obj0002, 0, LabelTime, lvl);
      } // if 
                 
   } // if   

   if(Show_Boxes)
   {  
     string dName = name+"boxes" ;
     if (ObjectFind(dName) != 0)
      {
          ObjectCreate(dName,OBJ_ARROW,0,Time[0],lvl);
          ObjectSet(dName,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(dName,OBJPROP_COLOR,Col);  
      } 
      else
      {
         ObjectMove(dName,0,Time[0],lvl);
      } 
   } // if    
 
}
//+------------------------------------------------------------------+

string fFill(string filled, int f ) 
{
   string FILLED ;
   
   FILLED = StringSubstr(filled + "                                         ",0,f) ;
   
return(FILLED);
}
//+-------------------------------------------------------------------------------------------+
//| Subroutine:  Get the chart scale number                                                   |
//+-------------------------------------------------------------------------------------------+
int ChartScaleGet()
  {
  long result = -1;
  ChartGetInteger(0,CHART_SCALE,0,result);
  return((int)result);
  }  
    


//+--------- TRO MODIFICATION ---------------------------------------+ 
void TRO()
{   
   
   string TRO_OBJ    = "TROTAG"  ;  
   ObjectCreate(TRO_OBJ, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(TRO_OBJ, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(TRO_OBJ, OBJPROP_CORNER, 3);
   ObjectSet(TRO_OBJ, OBJPROP_XDISTANCE, 5 );
   ObjectSet(TRO_OBJ, OBJPROP_YDISTANCE, 5 );  
}
//+------------------------------------------------------------------+ 