//+------------------------------------------------------------------+ 
//|   TRO_MyNotes                                                    | 
//|                                                                  | 
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+  
 

//----
#property indicator_chart_window

extern bool Show_Notes = true ;

extern int myChartX   = 10 ;
extern int myChartY   = 100 ;
extern int myCorner   = 0 ;
extern string myFont  = "Terminal" ;  // "Arial Bold"
extern int myFontSize = 20 ;
extern int myFillSize = 35 ; 
 

extern string myNote01 = "" ;
extern string myNote02 = "" ;
extern string myNote03 = "" ;
extern string myNote04 = "" ;
extern string myNote05 = "" ;
extern string myNote06 = "'" ;
extern string myNote07 = "" ;
extern string myNote08 = "" ;
extern string myNote09 = "" ;
extern string myNote10 = "" ;

extern color myColor01 = DimGray ;
extern color myColor02 = DimGray ;
extern color myColor03 = DimGray ;
extern color myColor04 = DimGray ;
extern color myColor05 = DimGray ;
extern color myColor06 = DimGray ;
extern color myColor07 = DimGray ;
extern color myColor08 = DimGray ;
extern color myColor09 = DimGray ;
extern color myColor10 = DimGray ;

//---- PipsToOpen
string Indicator_Name = "MyNotes:" ;
int Objs = 0;

//+------------------------------------------------------------------+ 

int init()
{
   
   deinit() ;

   if( Show_Notes ) {DoHelp () ;  }

   return(0);
}
 
//+------------------------------------------------------------------+
int deinit()
{

   for( int h = 0 ; h < 10 ; h++ )
   {
      ObjectDelete("aHelp"+h) ;
   }
   
   TRO();

   return(0);
}
 
//+------------------------------------------------------------------+
int start()
{
   WindowRedraw() ;   
   return(0);
}
//+------------------------------------------------------------------+
string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}

//+------------------------------------------------------------------+

void DoHelp()
{

string aHelp[10];
color aColor[10];

aHelp[0] =  myNote01 ;
aHelp[1] =  myNote02 ;
aHelp[2] =  myNote03 ;
aHelp[3] =  myNote04 ;
aHelp[4] =  myNote05 ;
aHelp[5] =  myNote06 ;
aHelp[6] =  myNote07 ;
aHelp[7] =  myNote08 ;
aHelp[8] =  myNote09 ;
aHelp[9] =  myNote10 ;

aColor[0] =  myColor01 ;
aColor[1] =  myColor02 ;
aColor[2] =  myColor03 ;
aColor[3] =  myColor04 ;
aColor[4] =  myColor05 ;
aColor[5] =  myColor06 ;
aColor[6] =  myColor07 ;
aColor[7] =  myColor08 ;
aColor[8] =  myColor09 ;
aColor[9] =  myColor10 ;


ArrayResize(aHelp,11) ;
ArrayResize(aColor,11) ;

for( int h = 0 ; h < 10 ; h++ )
{
   int yAxis =  myChartY + myFontSize + myFontSize*h;
   int xAxis =  myChartX + 10 ;
   
  if(aHelp[h] != "") { drawComment("aHelp"+h,aHelp[h] , xAxis , yAxis , aColor[h]  ) ; }
} 

}

//+------------------------------------------------------------------+  
 
void drawComment(string tLabel,string name, int xPos, int yPos ,color Color  )
{

ObjectCreate(tLabel,23,0,Time[0],PRICE_CLOSE);
ObjectSet(tLabel, OBJPROP_CORNER, myCorner );
ObjectSet(tLabel,OBJPROP_XDISTANCE,xPos);
ObjectSet(tLabel,OBJPROP_YDISTANCE,yPos);
ObjectSetText(tLabel,fFill(name,myFillSize),myFontSize,myFont,Color); 
}

//+------------------------------------------------------------------+

string fFill(string filled, int f ) 
{
   string FILLED ;
   
   FILLED = StringSubstr(filled + "                                         ",0,f) ;
   
return(FILLED);
}
//+------------------------------------------------------------------+  
void TRO()
{   
   
   string tObjName03    = "TROTAG"  ;  
   ObjectCreate(tObjName03, OBJ_LABEL, 0, 0, 0);//HiLow LABEL
   ObjectSetText(tObjName03, CharToStr(78) , 12 ,  "Wingdings",  DimGray );
   ObjectSet(tObjName03, OBJPROP_CORNER, 3);
   ObjectSet(tObjName03, OBJPROP_XDISTANCE, 5 );
   ObjectSet(tObjName03, OBJPROP_YDISTANCE, 5 );  
}
 
//+------------------------------------------------------------------+ 
/*

*/